// change radio:
function changeRadio(myRadios, val) {
  for (let i = 0; i < myRadios.length; i++) {
    if (myRadios[i].value === val) {
      myRadios[i].checked = true;
    } else {
      myRadios[i].checked = false;
    }
  }

  // console.log('ddddddddddddddddddd', val)
  if (val === "radio_voice") {
    document
      .querySelector("#radio_voice")
      .setAttribute("style", "display: flex;");
    document
      .querySelector("#radio_text")
      .setAttribute("style", "display: none;");
  } else {
    document
      .querySelector("#radio_voice")
      .setAttribute("style", "display: none;");
    document
      .querySelector("#radio_text")
      .setAttribute("style", "display: flex;");
  }
}

function getChatCompletionByComKey(msgs, userId, model, callback) {
  fetch("/cc/completionByModelByComKey", {
    method: "post",
    header: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify({
      messages: msgs,
      userId: userId,
      model: model,
    }),
  })
    .then(function (e) {
      return e.json();
    })
    .then(function (rlt) {
      callback(rlt);
    });
}

function addQues(quesInfo) {
  window.gpt35infoMsgs.push({
    role: "user",
    content: quesInfo
  })
  getChatCompletionByComKey(window.gpt35infoMsgs, localStorage.userId, window.openGPT35Name, function(rlt) {
    if (rlt && rlt.Result === 1 && rlt.data && rlt.data.choices && rlt.data.choices.length > 0) {
      let respMsg = rlt.data.choices[0].message
      window.gpt35infoMsgs.push(respMsg)
      rePaintGpt35info()

      document.querySelector('#quesInfo').value = ""
    }
    else {
      alert("getChatCompletionByComKey errinfo=>" + (rlt && rlt.data ? JSON.stringify(rlt.data.error) : ''))
    }
  })
}

function isInclickLimit() {
  if (window.clickInterval) return true;

  return false;
}
function clickLimitInvoke() {
  if (
    !document.querySelector("#getResp") ||
    !document.querySelector("#spanClickTimeLimit")
  ) {
    alert("we need button#getResp and span#spanClickTimeLimit");
    return;
  }
  var btnGetResp = document.querySelector("#getResp");
  btnGetResp.setAttribute("class", "btn-disabled");
  var spanClickTimeLimit = document.querySelector("#spanClickTimeLimit");
  spanClickTimeLimit.innerHTML = "(4s)";
  var clickIntervalFunc = function () {
    //- console.log('clickIntervalFunc 1/4')
    spanClickTimeLimit = document.querySelector("#spanClickTimeLimit");
    var matches = spanClickTimeLimit.innerHTML.match(/[0-9]{1,}/);
    if (matches) {
      //- console.log('clickIntervalFunc 2/4')
      var num = Number(matches[0]);
      if (num && num - 1 > 0) {
        console.log("clickIntervalFunc 4/4=>", num);
        spanClickTimeLimit.innerHTML = "(" + (num - 1) + "s)";
      } else {
        //- console.log('clickIntervalFunc 3/4')
        clearInterval(window.clickInterval);
        window.clickInterval = null;

        var btnGetResp = document.querySelector("#getResp");
        btnGetResp.setAttribute("class", "");
      }
    }
  };
  window.clickInterval = setInterval(clickIntervalFunc, 1000);
  clickIntervalFunc();
}

//- var gpt30infoStr_chat1 = ''
function init() {
  // 缓存清除按钮
  document.querySelector('#btnClearAndReload').onclick = function () {
    localStorage.clear()
    window.location.reload()
  }

  // 添加背景信息按钮
  document.querySelector('#addBgInfo').onclick = function () {
    var bgInfo = document.querySelector('#bgInfo').value

    window.gpt35infoMsgs.push({
      role:'system',
      content: bgInfo
    })
    rePaintGpt35info()

    tempSaveData()

    document.querySelector('#bgInfo').value = ""
  }

  // 获取回答
  document.querySelector('#getResp').onclick = function () {
    if (isInClickLimit()) return

    clickLimitInvoke()

    var quesInfo = document.querySelector('#quesInfo').value
    addQues(quesInfo)
  }

  if (!localStorage.userId) {
    localStorage.userId = 'oaid.' + String(Date.now()) + Math.floor(Math.random() * 10000)
  }
  if (localStorage[persistKeyPre + '_chat1']) {
    window.gpt35infoMsgs = JSON.parse(localStorage[persistKeyPre + '_chat1'] || [])
  }

  rePaintGpt35info()
}

function rePaintGpt35info() {
  var innerHtml = ''
  for (let i = 0; i < window.gpt35infoMsgs.length; i++) {
    var role = window.gpt35infoMsgs[i].role
    var cont = window.gpt35infoMsgs[i].content
    innerHtml += '<p><b>' + role + ': </b>' + cont.replace(/\n/gi, '<br />') + '</p>'
  }
  var dlgCon = document.querySelector("#gpt35Dlg")
  dlgCon.innerHTML = innerHtml
  dlgCon.scrollTop = dlgCon.scrollHeight
}

function tempSaveData() {
  localStorage[persistKeyPre + '_gpt35infoMsgs'] = JSON.stringify(window.gpt35infoMsgs)
  //- localStorage[persistKeyPre + '_gpt30infoStr'] = gpt30infoStr
}
